// OutputDevice.cpp: COutputDevice NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "vjb30030.h"
#include "OutputDevice.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

COutputDevice::COutputDevice()
{

}

COutputDevice::~COutputDevice()
{

}

//
//	@\	F	o̓t@C݃`FbN
//
//		F	pQueue - L[
//
//	Al	F	ʃR[h
//
//	@\F	O}̂ɏo͂t@C݂邩`FbNB
//
//	l	F	
//
int COutputDevice::CheckDstFile(Queue *pQueue)
{
	HANDLE	hdir;
	WIN32_FIND_DATA	findBuf;
	BOOL bFind;

	// Rs[fBNg擾
	m_sSrcDir = CreatePathName(g_sOutputDir, pQueue->sShikibetsuCode + pQueue->sVolLabel.SpanExcluding(","));

	hdir = FindFirstFile(CreatePathName(m_sSrcDir, "*"), &findBuf);
	if (hdir == INVALID_HANDLE_VALUE)
		return RC_NODIRECTORY;

	bFind = FALSE;
	do {
		if (findBuf.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY) {
			if (strcmp(findBuf.cFileName, ".") != 0 && strcmp(findBuf.cFileName, "..") != 0) {
				bFind = TRUE;
				break;
			}
		} else {
			bFind = TRUE;
			break;
		}
	} while (FindNextFile(hdir, &findBuf));

	FindClose(hdir);

	if (!bFind)
		return RC_NOFILE;

	return RC_NORMAL;
}

//
//	@\	F@{[x擾
//
//		F	pPath - foCX̃[gpX
//				sVolumeName - 擾ꂽ{[x
//
//	Al	F	TRUE - 
//				FALSE - G[i~j
//
//	@\F	O}̂̃{[x擾B
//
//	l	F	
//
BOOL COutputDevice::GetVolumeName(LPCTSTR pPath, CString &sVolumeName)
{
	char cVolumeName[256];
	DWORD dwMaxCompLen;
	DWORD dwFileSystemFlags;
	BOOL bResult;

	// {[擾
	while (TRUE) {
		bResult = GetVolumeInformation(
		   pPath,				// [gfBNgւ̃|C^
		   cVolumeName,			// {[i[obt@ւ̃|C^
		   sizeof(cVolumeName),	// lpVolumeNameBuffer obt@̃TCY
		   NULL,				// {[VAio[i[ϐւ̃|C^
		   &dwMaxCompLen,		// t@C\vf̍ő咷i[ϐւ̃|C^
		   &dwFileSystemFlags,	// t@CVXetOi[ϐւ̃|C^
		   NULL,				// t@CVXei[obt@ւ̃|C^
		   0					// lpFileSystemNameBuffer obt@̃TCY
		);
		if (bResult)
			break;
		else {
			if (GetLastError() == ERROR_NOT_READY) {
				if (DispMessage(IDS_MSG_NOT_READY, MB_OKCANCEL, FALSE, pPath) == IDCANCEL)
					return FALSE;
			} else
				return FALSE;
		}
	}

	sVolumeName = cVolumeName;

	return TRUE;
}

//
//	@\	F@G[擾
//
//		F	nErrorCode - G[R[h
//				sErrorMsg - G[e
//
//	Al	F	
//
//	@\F	G[擾̃ftHgB
//
//	l	F	KvɉČpNXŃI[o[ChB
//
void COutputDevice::GetError(int &nErrorCode, CString &sErrorMsg)
{
	nErrorCode = 0;
}
